<?php

namespace Digipay\Darkness\Pay;

class DigiPayGatway
{
    const URL = "https://proxy.bgpay.digital/api/payment/request";
    private $amount;
    private $currency;
    private $app_key;
    private $secrete_key;
    private $secrete_key_test;
    private $public_key;
    private $public_key_test;
    private $ref_commande;
    private $commande_name;
    private $mode;//prod|test;
    private $success_url;
    private $ipn_url;
    private $cancel_url;
    private $failed_url;
    private $data_transactions = [];
    private $client_name  = '' ;
    private $client_phone = '' ;
    private $client_email = '' ;

    function __constructor()
    {

    }

    /**
     * @return string
     */
    public function getClientName()
    {
        return $this->client_name;
    }

    /**
     * @param string $client_name
     */
    public function setClientName($client_name)
    {
        $this->client_name = $client_name;
    }

    /**
     * @return string
     */
    public function getClientPhone()
    {
        return $this->client_phone;
    }

    /**
     * @param string $client_phone
     */
    public function setClientPhone($client_phone)
    {
        $this->client_phone = $client_phone;
    }

    /**
     * @return string
     */
    public function getClientEmail()
    {
        return $this->client_email;
    }

    /**
     * @param string $client_email
     */
    public function setClientEmail($client_email)
    {
        $this->client_email = $client_email;
    }

    const MODE_TEST = 'test';
    const MODE_PROD = 'prod';

    /**
     * @return mixed
     */
    public function getAmount()
    {
        return $this->amount;
    }

    /**
     * @param mixed $amount
     */
    public function setAmount($amount)
    {
        $this->amount = $amount;
    }

    /**
     * @return mixed
     */
    public function getCurrency()
    {
        return $this->currency;
    }

    /**
     * @param mixed $currency
     */
    public function setCurrency($currency)
    {
        $this->currency = $currency;
    }

    /**
     * @return mixed
     */
    public function getAppKey()
    {
        return $this->app_key;
    }

    /**
     * @param mixed $app_key
     */
    public function setAppKey($app_key)
    {
        $this->app_key = $app_key;
    }

    /**
     * @return mixed
     */
    public function getSecreteKey()
    {
        return $this->secrete_key;
    }

    /**
     * @param mixed $secrete_key
     */
    public function setSecreteKey($secrete_key)
    {
        $this->secrete_key = $secrete_key;
    }

    /**
     * @return mixed
     */
    public function getPublicKey()
    {
        return $this->public_key;
    }

    /**
     * @param mixed $public_key
     */
    public function setPublicKey($public_key)
    {
        $this->public_key = $public_key;
    }

    /**
     * @return mixed
     */
    public function getRefCommande()
    {
        return $this->ref_commande;
    }

    /**
     * @param mixed $ref_commande
     */
    public function setRefCommande($ref_commande)
    {
        $this->ref_commande = $ref_commande;
    }

    /**
     * @return mixed
     */
    public function getCommandeName()
    {
        return $this->commande_name;
    }

    /**
     * @param mixed $commande_name
     */
    public function setCommandeName($commande_name)
    {
        $this->commande_name = $commande_name;
    }

    /**
     * @return mixed
     */
    public function getMode()
    {
        return $this->mode;
    }

    /**
     * @param mixed $mode
     */
    public function setMode($mode)
    {
        $this->mode = $mode;
    }

    /**
     * @return mixed
     */
    public function getSuccessUrl()
    {
        return $this->success_url;
    }

    /**
     * @param mixed $success_url
     */
    public function setSuccessUrl($success_url)
    {
        $this->success_url = $success_url;
    }

    /**
     * @return mixed
     */
    public function getIpnUrl()
    {
        return $this->ipn_url;
    }

    /**
     * @param mixed $ipn_url
     */
    public function setIpnUrl($ipn_url)
    {
        $this->ipn_url = $ipn_url;
    }

    /**
     * @return mixed
     */
    public function getCancelUrl()
    {
        return $this->cancel_url;
    }

    /**
     * @param mixed $cancel_url
     */
    public function setCancelUrl($cancel_url)
    {
        $this->cancel_url = $cancel_url;
    }

    /**
     * @return mixed
     */
    public function getFailedUrl()
    {
        return $this->failed_url;
    }

    /**
     * @param mixed $failed_url
     */
    public function setFailedUrl($failed_url)
    {
        $this->failed_url = $failed_url;
    }

    /**
     * @return mixed
     */
    public function getDataTransactions()
    {
        return $this->data_transactions;
    }

    /**
     * @param mixed $data_transactions
     */
    public function setDataTransactions($data_transactions)
    {
        $this->data_transactions = $data_transactions;
    }

    /**
     * @return mixed
     */
    public function getSecreteKeyTest()
    {
        return $this->secrete_key_test;
    }

    /**
     * @param mixed $secrete_key_test
     */
    public function setSecreteKeyTest($secrete_key_test)
    {
        $this->secrete_key_test = $secrete_key_test;
    }

    /**
     * @return mixed
     */
    public function getPublicKeyTest()
    {
        return $this->public_key_test;
    }

    /**
     * @param mixed $public_key_test
     */
    public function setPublicKeyTest($public_key_test)
    {
        $this->public_key_test = $public_key_test;
    }


    public function start()
    {
        $strPostField = json_encode(
            array(
                "amount" => $this->getAmount(),
                "currency" => $this->getCurrency(),
                "app_key" => $this->getAppKey(),
                "secrete_key" => $this->getMode() === 'prod' ? $this->getSecreteKey() : $this->getSecreteKeyTest(),
                "public_key" => $this->getMode() === 'prod' ? $this->getPublicKey() : $this->getPublicKeyTest(),
                "ref_commande" => $this->getRefCommande(),
                "commande_name" => $this->getCommandeName(),
                "mode" => $this->getMode(),
                "success_url" => $this->getSuccessUrl(),
                "ipn_url" => $this->getIpnUrl(),
                "cancel_url" => $this->getCancelUrl(),
                "failed_url" => $this->getFailedUrl(),
                "data_transactions" =>
                    json_encode($this->getDataTransactions()),
                "client_name"=>$this->getClientName(),
                "client_phone"=>$this->getClientPhone(),
                "client_email"=>$this->getClientEmail(),
            )

        );
        $ch = curl_init(self::URL);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $strPostField);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Content-Type: application/json'
        ]);

        $response = curl_exec($ch);
        return json_decode($response, true);
    }
}
